{% block swag_guided_shopping_presentation_detail_appointments %}
<div>
    <sw-card v-if="acl.can('guided_shopping_appointment.viewer')"
             class="swag-guided-shopping-presentation-detail-appointments"
             position-identifier="swag-guided-shopping-presentation-detail-appointments"
             :title="$tc('swag-guided-shopping-presentation.detailBase.cardTitleAppointments')"
             :isLoading="isLoading"
    >

        {% block sw_card_toolbar %}
            <div class="sw-card__toolbar">
                <sw-card-filter :placeholder="$tc('swag-guided-shopping-presentation.detailAppointments.filter')"
                                @sw-card-filter-term-change="onSearchTermChange"
                                class="swag-guided-shopping-presentation-detail-appointments__filter-input">
                    <template #filter>
                        <div>
                            {% block swag_guided_shopping_presentation_appointments_overview_option_list_toolbar_container_filter_list %}
                                <div class="swag-guided-shopping-presentation-appointments-overview__filter-list-button">
                                    {% block swag_guided_shopping_presentation_detail_appointments_add_button %}
                                        <sw-button
                                                v-tooltip="{
                                                    message: onEditPresentationStructure,
                                                    disabled: acl.can('guided_shopping_appointment.creator') && isSystemDefaultLanguage,
                                                    showOnDisabledElements: true
                                                }"
                                                class="swag-guided-shopping-presentation-detail-appointments__add-appointment-action"
                                                size="small"
                                                :disabled="!acl.can('guided_shopping_appointment.creator') || !isSystemLanguage"
                                                @click="onCreateNewAppointment">
                                            <sw-icon name="regular-plus-circle-s" small></sw-icon>
                                            {{ $tc('swag-guided-shopping-presentation.detailAppointments.buttonAddAppointment') }}
                                        </sw-button>
                                    {% endblock %}
                                </div>
                            {% endblock %}
                        </div>
                    </template>
                </sw-card-filter>
            </div>
        {% endblock %}

        {% block swag_guided_shopping_presentation_detail_appointments_add_modal %}
            <sw-modal v-if="currentAppointment"
                      variant="large"
                      class="swag-guided-shopping-presentation-appointments-overview__modal"
                      @modal-close="onCloseModal"
                      :title="currentAppointment.name ? currentAppointment.name : $tc('swag-guided-shopping-presentation.detailAppointments.modalTitleAppointment')"
                      :closable="false"
                      >

                {% block swag_guided_shopping_presentation_detail_appointments_add_modal_appointment_form %}
                    <swag-guided-shopping-appointment-form
                        :ref="(el) => { appointmentForm = el }"
                        :appointment="currentAppointment"
                        :cachedAppointmentData="cachedAppointmentData"
                        :isLoading="isLoading"
                        :isModal="true"
                        @cancel-recipient="onCancelRecipient"
                    >

                    </swag-guided-shopping-appointment-form>
                {% endblock %}

                {% block swag_guided_shopping_presentation_detail_appointments_add_modal_footer %}
                    <template #modal-footer>
                        {% block swag_guided_shopping_presentation_detail_appointments_add_modal_cancel_appointment %}
                            <sw-button
                                v-if="!currentAppointment._isNew"
                                variant="ghost-danger"
                                size="small"
                                @click="onOpenCancelAppointmentModal"
                            >
                                {{ $tc('swag-guided-shopping-presentation.detailAppointments.buttonCancelAppointment') }}
                            </sw-button>
                            <div v-else />
                        {% endblock %}
                        <div class="swag-guided-shopping-presentation-appointments-overview__modal-action">
                            {% block swag_guided_shopping_presentation_detail_appointments_add_modal_cancel %}
                                <sw-button size="small" @click="onCloseModal">
                                    {{ $tc('swag-guided-shopping-presentation.detailAppointments.buttonCancel') }}
                                </sw-button>
                            {% endblock %}

                            {% block swag_guided_shopping_presentation_detail_appointments_add_modal_apply %}
                                <sw-button-group
                                    v-if="appointmentForm"
                                    class="sw-product-detail__save-button-group"
                                    :split-button="true"
                                >
                                    {% block sw_product_detail_actions_save %}
                                        <sw-button variant="primary" size="small" @click="onSaveAppointment(appointmentForm.canSendMail)" :disabled="!acl.can('guided_shopping_appointment.editor') || !appointmentForm.isDirty">
                                          {{ appointmentForm.canSendMail ? $tc('swag-guided-shopping-presentation.detailAppointments.buttonSend') : $tc('swag-guided-shopping-presentation.detailAppointments.buttonApply') }}
                                        </sw-button>
                                    {% endblock %}

                                    {% block sw_product_detail_actions_save_without_send %}
                                        <sw-context-button v-if="appointmentForm.canSendMail">
                                            <template #button>
                                                <sw-button square variant="primary" size="small">
                                                    <sw-icon name="regular-chevron-down-xs" size="16" />
                                                </sw-button>
                                            </template>

                                            {% block sw_product_detail_actions_save_without_send_button %}
                                                <sw-context-menu-item
                                                    @click="onSaveAppointment(false)"
                                                >
                                                    {{ $tc('swag-guided-shopping-presentation.detailAppointments.buttonApplyWithoutSend') }}
                                                </sw-context-menu-item>
                                            {% endblock %}
                                        </sw-context-button>
                                    {% endblock %}
                                </sw-button-group>
                            {% endblock %}
                        </div>
                    </template>
                {% endblock %}
            </sw-modal>
        {% endblock %}

        {% block swag_guided_shopping_presentation_detail_appointments_grid %}
            <template #grid>
                <sw-entity-listing
                            v-if="total"
                            :items="appointments"
                            :repository="appointmentRepository"
                            :columns="appointmentColumns"
                            :show-selection="false"
                            :full-page="false"
                            :allow-inline-edit="acl.can('guided_shopping_appointment.editor')"
                            :allow-edit="acl.can('guided_shopping_appointment.editor')"
                            :allow-delete="acl.can('guided_shopping_appointment.deleter')"
                            detailRoute="swag.guided.shopping.appointment.detail"
                            class="swag-guided-shopping-presentation-appointments-overview__data-grid guide-shopping-table"
                            >

                    {% block swag_guided_shopping_presentation_detail_appointments_grid_columns %}
                        {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_name %}
                            <template #column-name="{ item, column }">
                                <div class="column-wrapper">
                                    <div class="name">
                                        <a :href="$router.resolve({ name: column.routerLink, params: {id: item.id}}).href"
                                        @click.prevent="onEditAppointment(item.id)">
                                            {{ item.translated.name ?? item.name }} <span class="path" v-if="item.presentationPath != item.id">/{{ item.presentationPath }}</span>
                                        </a>
                                    </div>
                                    <div class="mode-date">
                                        <span>
                                            {{ item.mode === 'self' && !item.endedAt ? $tc('swag-guided-shopping-presentation.detailAppointments.textSelfMode')
                                                : $tc('swag-guided-shopping-presentation.detailAppointments.textGuidedfMode')}},
                                            {{ item.salesChannelDomain.language.name }}
                                        </span>
                                    </div>
                                </div>
                            </template>
                        {% endblock %}
                        {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_running %}
                          {% set dateFormat = value %}
                            <template #column-activity="{ item }">
                                <template v-if="item.mode === 'self' && !item.startedAt">
                                    <div class="column-wrapper">
                                        <div>
                                            <span class="dash">{{ $tc('global.default.from') }}</span>
                                            <span class="from" v-if="item.accessibleFrom">{{ item.accessibleFrom|date({ month: 'numeric', year: 'numeric', hour: 'numeric', minute: 'numeric'}) }}</span>
                                            <span class="from" v-else>{{ item.createdAt|date({ month: 'numeric', year: 'numeric', hour: 'numeric', minute: 'numeric'}) }}</span>
                                        </div>
                                        <div v-if="item.accessibleTo">
                                            <span class="dash" >{{ $tc('global.default.to') }}</span>
                                            <span class="till">{{ item.accessibleTo|date({ month: 'numeric', year: 'numeric', hour: 'numeric', minute: 'numeric'}) }}</span>
                                        </div>
                                    </div>
                                </template>
                                <template v-else>
                                    <div class="column-wrapper">
                                        <template v-if="item.startedAt">
                                            <div>
                                                <span class="dash">{{ $tc('global.default.from') }}</span>
                                                <span class="from">{{ item.startedAt|date({ month: 'numeric', year: 'numeric', hour: 'numeric', minute: 'numeric'}) }}</span>
                                            </div>
                                            <div v-if="item.endedAt">
                                                <span class="dash" >{{ $tc('global.default.to') }}</span>
                                                <span class="till" >{{ item.endedAt|date({ month: 'numeric', year: 'numeric', hour: 'numeric', minute: 'numeric'}) }}</span>
                                            </div>
                                        </template>

                                        <div>
                                            <span class="not-started" v-if="item.mode !== 'self' && !item.startedAt">
                                                - {{ $tc('swag-guided-shopping-appointment.base.configuration.notStarted') }} -
                                            </span>
                                        </div>
                                    </div>
                                </template>
                            </template>
                        {% endblock %}
                        {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_urls %}
                            <template #column-urls="{ item, isInlineEdit }">
                                <swag-guided-shopping-appointment-urls
                                        :appointment="item"
                                        :small="true"
                                />
                            </template>
                        {% endblock %}
                        {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_guide_name %}
                            <template #column-guideName="{ item, isInlineEdit }">
                                <template v-if="item.guideUser">
                                    {{ getUserName(item.guideUser) }}
                                </template>
                                <template v-else-if="item.mode === 'self' && !item.startedAt">
                                    -
                                </template>
                            </template>
                        {% endblock %}

                    {% endblock %}

                    {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_actions %}
                        <template #actions="{ item }">

                            {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_actions_edit %}
                                <sw-context-menu-item @click="onEditAppointment(item.id)" :disabled="!acl.can('guided_shopping_appointment.editor')">
                                    {{ $tc('swag-guided-shopping-presentation.detailAppointments.contextMenuEdit') }}
                                </sw-context-menu-item>
                            {% endblock %}

                            {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_actions_delete %}
                                <sw-context-menu-item @click="onDeleteAppointment(item.id)" variant="danger" :disabled="!acl.can('guided_shopping_appointment.deleter')">
                                    {{ $tc('swag-guided-shopping-presentation.detailAppointments.contextMenuDelete') }}
                                </sw-context-menu-item>
                            {% endblock %}
                        </template>
                    {% endblock %}

                    {% block swag_guided_shopping_presentation_detail_appointments_grid_columns_action_modals %}
                        <template #action-modals="{ item }">
                            {% block swag_guided_shopping_presentation_detail_appointments_delete_modal %}
                                <sw-modal v-if="showDeleteModal === item.id"
                                          @modal-close="onCloseDeleteModal"
                                          :title="$tc('global.default.warning')"
                                          appointment="small">
                                    {% block swag_guided_shopping_presentation_detail_appointments_delete_modal_confirm_delete_text %}
                                        <p class="swag-guided-shopping-presentation-detail-appointments__confirm-delete-text">
                                            {{ $tc('swag-guided-shopping-presentation.detailAppointments.textDeleteAppointmentConfirm',0, {name: item.name}) }}
                                        </p>
                                    {% endblock %}

                                    {% block swag_guided_shopping_presentation_detail_appointments_delete_modal_footer %}
                                        <template #modal-footer>
                                            {% block swag_guided_shopping_presentation_detail_appointments_delete_modal_cancel %}
                                                <sw-button @click="onCloseDeleteModal"
                                                           size="small">
                                                    {{ $tc('swag-guided-shopping-presentation.detailAppointments.buttonCancel') }}
                                                </sw-button>
                                            {% endblock %}

                                            {% block swag_guided_shopping_presentation_detail_appointments_delete_modal_confirm %}
                                                <sw-button @click="onConfirmDeleteAppointment(item.id)"
                                                           variant="danger"
                                                           size="small">
                                                    {{ $tc('swag-guided-shopping-presentation.detailAppointments.buttonDelete') }}
                                                </sw-button>
                                            {% endblock %}
                                        </template>
                                    {% endblock %}
                                </sw-modal>
                            {% endblock %}
                        </template>
                    {% endblock %}

                    {% block swag_guided_shopping_presentation_appointments_overview_pagination %}
                        <template #pagination>
                            <sw-pagination :page="page"
                                           :limit="limit"
                                           :total="total"
                                           :total-visible="10"
                                           @page-change="onPageChange">
                            </sw-pagination>
                        </template>
                    {% endblock %}
                </sw-entity-listing>

                {% block swag_guided_shopping_presentation_cms_page_assignment_empty_state %}
                    <sw-empty-state
                            v-if="!total && !appointmentsLoading"
                            class="swag-guided-shopping-presentation-appointment-assignment__option-list-empty-state"
                            title=""
                            :absolute="false"
                            :subline="$tc('swag-guided-shopping-presentation.base.appointments.assignEmptyStateDescription')">
                        <template #icon>
                            <img :src="'/swagguidedshopping/static/img/empty-states/appointments-empty-state.svg' | asset">
                        </template>
                    </sw-empty-state>
                {% endblock %}

            </template>
        {% endblock %}

    </sw-card>

    {% block swag_guided_shopping_presentation_detail_appointments_cancel_modal %}
        <swag-guided-shopping-appointment-cancel-modal
            v-if="currentCancelAppointment"
            :appointment="currentCancelAppointment"
            @closeModal="onCloseCancelAppointmentModal"
            @confirmCancel="onConfirmCancelAppointment"
        >
        </swag-guided-shopping-appointment-cancel-modal>
    {% endblock %}
    {% block swag_guided_shopping_appointment_send_appointment_modal %}
        <swag-guided-shopping-appointment-send-appointment-modal
            v-if="showSendAppointmentModal"
            @closeModal="onCloseSendAppointmentModal"
            @confirmSend="onSendMailToAttendees"
        >
        </swag-guided-shopping-appointment-send-appointment-modal>
    {% endblock %}
</div>
{% endblock %}
